package PROCURA;

$PROCURA::VERSION = "1.31";

use Exporter;
use vars qw(@ISA @EXPORT);

@ISA     = qw(Exporter DynaLoader);
@EXPORT  = qw(); 

use DynaLoader;
#require DynaLoader;
use strict;

bootstrap PROCURA $PROCURA::VERSION;

1;
__END__

=head1 NAME

PROCURA - Perl extension for ftok, shmstat and mktime

=head1 SYNOPSIS

  use PROCURA;

  # $key = ftok (path [, id]);
  #    id  defaults to 65 ('A')
  $key = ftok ($ENV{DBPATH});

  # @stat = shmstat ($id);
  ($cuid, $cgid, $uid, $gid, $mode, $seq, $key,
   $segsz, $cpid, $lpid, $nattch, $atime, $dtime, $ctime) =
      shmstat ($id);

  # $secs = mktime (sec, min, hr, day, mon, yr);
  $oldyear = mktime (59, 59, 23, 31, 12, 96);
  $newyear = $oldyear + 1;

  # BEL: n_parm, s_parm
  $auth = dbd_bel_auth (457519101, "012280120320030622803349");
  # BEV: n_parm, s_parm
  $auth = dbd_bev_auth (457519101, "012280120320030622803349");
  # LEP: parm =~ s/^v_\@//, waarde
  $auth = dbd_lep_auth ("221108791", 826989207);

=head1 DESCRIPTION

ftok and mktime internals are well documented in UNIX standard manual
pages.

=head1 AUTHOR

H.Merijn Brand <h.m.brand@procura.nl>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 1996-2005 H.Merijn Brand for PROCURA B.V.

This library is not free software; you can't redistribute it

=head1 SEE ALSO

perl(1), ftok(3), mktime(3).

=cut
