package PROCURA::Cache;

=head1 NAME

Cache - Supply caching for PROCURA::DBD

=head1 SYNOPSIS

 use PROCURA::Cache;

=head1 DESCRIPTION

This is a placeholder for the several Caching modules that
exist for PROCURA::DBD supported products, documenting the
methods that are shared among them.

If the current B<$PROD> is "bev", C<use PROCURA::Cache;> is
equal to C<use PROCURA::Cache::BEV>.

=over 4

=item

=item B<maxcache ($table[, $maxcache])>

With this method you can request the maxchache for a specific table or set
the upper cache boud for the table passing it as a second argument.

=item B<cachestats ()>

At any point this method can supply cache hit statistics.

=item B<stopcache ()>

When Caching isn't needed anymore, all internal structures and database handles
concerning the cache can be freed with this method.

=back

=cut

use strict;
use Exporter;
use Carp;
use vars qw($VERSION @ISA);

$VERSION = "1.01";
@ISA     = ("Exporter", scalar caller);

sub import
{
    my $p = uc $ENV{PROD} or return 1;

    shift;
    eval "package ". caller () ."; use PROCURA::Cache::$p qw(@_)";
    $@ or return 1;
    carp "$@\nCaching for $p is not (yet) supported";
    0;
    } # import
