package PROCURA::Conv;

$PROCURA::Conv::VERSION = 4.02;

=head1 NAME

Conv - Conversion utilities

=head1 SYNOPSIS

    use PROCURA::Conv;

    # COBOL formatted numerics
    $n = comp3num ("\x01\x99\x90\x10\x1F");	# result 19990101

=head1 DESCRIPTION

=over 4

=item C<$num> = B<comp3num (>S<$comp3>B<);>

NYI help

=back

=head1 BUGS

Far from complete

=cut

### ###########################################################################

use Exporter;
use vars qw(@ISA @EXPORT);

@ISA	 = qw(Exporter);
@EXPORT	 = qw(comp3num
	      conv_debug);

use PROCURA::Diac;
use strict;

use vars qw($debug);
$debug   = 0;

sub conv_debug
{
    $debug = $_[0];
    } # rpt_debug

sub comp3num ($)
{
    my $f = shift;
#   int (substr (sprintf "%02X%02X%02X%02X%02X", unpack ("CCCCC", $f)), 0, 9);
    my $s = sprintf "%08X%02X", unpack ("NC", $f);
    my $n = int (substr $s, 0, 9);
    # F: unsigned, C: positive, D: Negative
    $s =~ m/D$/ ? -$n : $n;
    } # comp3num

1;
