;# $Header: curses.pl, v 1.0 94/07/12 hmb $
;#
;# Try to emulate the curses C-library calls
;#

require "terminfo.pl";

$ti_x		= 0;
$ti_y		= 0;
$ti_attr	= 0;
$ti_win		= STDOUT;

$stdscr		= STDOUT;

$A_NORMAL	= 00000;
$A_STANDOUT	= 00004;
$A_UNDERLINE	= 00010;
$A_REVERSE	= 00020;
$A_BLINK	= 00040;
$A_DIM		= 00100;
$A_BOLD		= 00200;
$A_INVIS	= 00400;
$A_PROTECT	= 01000;
$A_ALTCHARSET	= 02000;
$A_BLANK	= $A_INVIS;

;# &addch ($ch);
sub addch {
      local ($ch) = @_;

      print $ti_win $ch;
      } # addch

;# &addstr ($str);
sub addstr {
      local ($str) = @_;

      print $ti_win $str;
      } # addstr

;# &attroff ($attrs);
sub attroff {
      local ($attrs) = @_;

      $ti_attr &= ~($attrs);
      &attrset ($ti_attr);
      } # attroff

;# &attron ($attrs);
sub attron {
      local ($attrs) = @_;

      $ti_attr |= $attrs;
      &attrset ($ti_attr);
      } # attron

;# &attrset ($attrs);
sub attrset {
      local ($attrs) = @_;
      local ($s, $p1, $p2, $p3, $p4, $p5, $p6, $p7, $p8, $p9);

      $ti_attr = $attrs;
      if    ($ti_attr == $A_NORMAL) {
	    $s = $TI{"sgr0"};
	    }
      elsif ($ti_attr == $A_STANDOUT) {
	    $s = $TI{"smso"};
	    }
      elsif ($ti_attr == $A_UNDERLINE) {
	    $s = $TI{"smul"};
	    }
      elsif ($ti_attr == $A_REVERSE) {
	    $s = $TI{"rev"};
	    }
      elsif ($ti_attr == $A_BLINK) {
	    $s = $TI{"blink"};
	    }
      elsif ($ti_attr == $A_DIM) {
	    $s = $TI{"dim"};
	    }
      elsif ($ti_attr == $A_BOLD) {
	    $s = $TI{"bold"};
	    }
      elsif ($ti_attr == $A_BLANK) {
	    $s = $TI{"invis"};
	    }
      elsif ($ti_attr == $A_PROTECT) {
	    $s = $TI{"prot"};
	    }
      elsif ($ti_attr == $A_ALTCHARSET) {
	    $s = $TI{"smacs"};
	    }
      else {
	    $p1 = $ti_attr & $A_STANDOUT	? 1 : 0;
	    $p2 = $ti_attr & $A_UNDERLINE	? 1 : 0;
	    $p3 = $ti_attr & $A_REVERSE		? 1 : 0;
	    $p4 = $ti_attr & $A_BLINK		? 1 : 0;
	    $p5 = $ti_attr & $A_DIM		? 1 : 0;
	    $p6 = $ti_attr & $A_BOLD		? 1 : 0;
	    $p7 = $ti_attr & $A_BLANK		? 1 : 0;
	    $p8 = $ti_attr & $A_PROTECT		? 1 : 0;
	    $p9 = $ti_attr & $A_ALTCHARSET	? 1 : 0;
	    $s = &tparinf ($TI{"sgr"},
		  $p1, $p2, $p3, $p4, $p5, $p6, $p6, $p7, $p8, $p9);
	    }
      &tputinf ($s, 0, $ti_win);
      } # attrset

;# &baudrate ();

;# &beep ();
sub beep {
      &tputinf ($TI{"bel"}, 0, $ti_win);
      } # beep

;# &box ($win, $vert, $hor);

;# &clear ();
sub clear {
      &tputinf ($TI{"clear"}, 0, $ti_win);
      } # clear

;# &clearok ($win, $bf)

;# &clrtobot ();
sub clrtobot {
      &tputinf ($TI{"ed"}, 0, $ti_win);
      } # clrtobot

;# &clrtoeol ();
sub clrtoeol {
      &tputinf ($TI{"el"}, 0, $ti_win);
      } # clrtoeol

;# &cbreak ();
;# &delay_output ($ms);

;# &delch ();
sub delch {
      &tputinf ($TI{"dch1"}, 0, $ti_win);
      } # delch

;# &deleteln ();
sub deleteln {
      &tputinf ($TI{"dl1"}, 0, $ti_win);
      } # deleteln

;# &delwin ($win);
;# &doupdate ();
;# &echo ();
;# &endwin ();
;# &erase ();
;# &erasechar ();
;# &fixterm ();

;# &flash ();
sub flash {
      &tputinf ($TI{"flash"} ? $TI{"flash"} : $TI{"bel"}, 0, $ti_win);
      } # flash

;# &flushinp ();
;# &getch ();
;# &getstr ($str);
;# &gettmode ();
;# &getyx ($win, $y, $x);
;# &has_ic ();
;# &has_il ();
;# &idlok ($win, $bf);
;# &inch ();

;# &initscr ([$FH]);
sub initscr {
      local ($FH, $nc) = @_;
      local ($fh);

      &tgetinf ();
      $ti_win = $FH if $FH;
      $fh = select ($ti_win);
      $| = 1;
      select ($fh);
      &clear () unless $nc == 0;
      $curses = 1;
      } # initscr

;# &insch ($c);
sub insch {
      local ($c) = @_;

      &tputinf ($TI{"ich1"});
      print $ti_win $c;
      } # insch

;# &insertln ();
sub insertln {
      &tputinf ($TI{"il1"});
      } # insertln

;# &intrflush ($win, $bf);
;# &keypad ($win, $bf);
;# &killchar ();
;# &leaveok ($win, $flag);
;# &longname ();
;# &meta ($win, $flag);

;# &move ($y, $x);
sub move {
      local ($y, $x) = @_;

      &tputinf (&tparinf ($TI{"cup"}, $y, $x), 0, $ti_win);
      } # move

;# &mvaddch ($y, $x, $ch);
sub mvaddch {
      local ($y, $x, $ch) = @_;

      &tputinf (&tparinf ($TI{"cup"}, $y, $x), 0, $ti_win);
      print $ti_win $ch;
      } # mvaddch

;# &mvaddstr ($y, $x, $str);
sub mvaddstr {
      local ($y, $x, $str) = @_;

      &tputinf (&tparinf ($TI{"cup"}, $y, $x), 0, $ti_win);
      print $ti_win $str;
      } # mvaddstr

;# &mvcur ($oldrow, $oldcol, $newrow, $newcol);

;# &mvdelch ($y, $x);
sub mvdelch {
      local ($y, $x) = @_;

      &tputinf (&tparinf ($TI{"cup"}, $y, $x), 0, $ti_win);
      &tputinf ($TI{"dch1"}, 0, $ti_win);
      } # mvdelch

;# &mvgetch ($y, $x);
;# :

;# &mvwscanw ($win, $y, $x, $fmt, $args);;
;# :

;# &standend ();
sub standend {
      &tputinf ($TI{"rmso"}, 0, $ti_win);
      } # standend

;# &standout ();
sub standout {
      &tputinf ($TI{"smso"}, 0, $ti_win);
      } # standout
